# `saferef`

#### Refactored "safe reference" from dispatcher.py

The saferef module is accessible via the `sqlobject.include.pydispatch` module.

## Attributes

#### a `__package__`

    'sqlobject.include.pydispatch'

## Functions

#### f `safeRef(target, onDelete=None)` ...

Return a safe weak reference to a callable target

target -- the object to be weakly referenced, if it's a
  bound method reference, will create a BoundMethodWeakref, otherwise creates a simple weakref.
onDelete -- if provided, will have a hard reference stored
  to the callable to be called after the safe reference goes out of scope with the reference object, (either a weakref or a BoundMethodWeakref) as argument.

## Classes

#### C `BoundMethodWeakref(...)` ...

'Safe' and reusable weak references to instance methods

BoundMethodWeakref objects provide a mechanism for referencing a bound method without requiring that the method object itself (which is normally a transient object) is kept alive. Instead, the BoundMethodWeakref object keeps weak references to both the object and the function which together define the instance method.

Attributes:
  key -- the identity key for the reference, calculated
    by the class's calculateKey method applied to the target instance method
  deletionMethods -- sequence of callable objects taking
    single argument, a reference to this object which will be called when either the target object or target function is garbage collected (i.e. when this object becomes invalid). These are specified as the onDelete parameters of safeRef calls.

  System Message: WARNING/2 (`sqlobject.include.pydispatch.saferef.BoundMethodWeakref`, line 18)

  Definition list ends without a blank line; unexpected unindent.

  weakSelf -- weak reference to the target object weakFunc -- weak reference to the target function

Class Attributes:
  _allInstances -- class attribute pointing to all live
    BoundMethodWeakref objects indexed by the class's calculateKey(target) method applied to the target objects. This weak value dictionary is used to short-circuit creation so that multiple references to the same (object, function) pair produce the same BoundMethodWeakref instance.

This class contains 8 members.

See the source for more information.